CXREF(1P)

PROLOG
This manual page is part of the POSIX Programmer's Manual. The Linux implementation of this interface may differ (consult the corresponding Linux manual page for details of Linux behavior), or the interface may not be implemented on Linux.

NAME
cxref - generate a C-language program cross-reference table (DEVELOPMENT)

SYNOPSIS

cxref [-cs][-o file][-w num] [-D name[=def]]...[-I dir]...
[-U name]... file ...

DESCRIPTION

The cxref utility shall analyze a collection of C-language files and attempt to build a cross-reference table. Information from #define lines shall be included in the symbol table. A sorted listing shall be written to standard output of all symbols (auto, static, and global) in each file separately, or with the -c option, in combination. Each symbol shall contain an asterisk before the declaring reference.

OPTIONS

The cxref utility shall conform to the Base Definitions volume of IEEE Std 1003.1-2001, Section 12.2, Utility Syntax Guidelines, except that the order of the -D, -I, and -U options (which are identical to their interpretation by c99) is significant. The following options shall be supported:

-c  Write a combined cross-reference of all input files.

-s  Operate silently; do not print input filenames.

-o  file
    Direct output to named file.

-w  num
    Format output no wider than num (decimal) columns. This option defaults to 80 if num is not specified or is less than 51.

-D  Equivalent to c99.

-I  Equivalent to c99.

-U  Equivalent to c99.

OPERANDS

The following operand shall be supported:

file
    A pathname of a C-language source file.

STDIN

Not used.

INPUT FILES

The input files are C-language source files.

ENVIRONMENT VARIABLES

The following environment variables shall affect the execution of cxref:

LANG
    Provide a default value for the internationalization variables that are unset or null. (See the Base Definitions volume of IEEE Std 1003.1-2001, Section 8.2, Internationalization Variables for the precedence of internationalization variables used to determine the values of locale categories.)

LC_ALL
    If set to a non-empty string value, override the values of all the other internationalization variables.

LC_COLLATE

    Determine the locale for the ordering of the output.

LC_CTYPE
    Determine the locale for the interpretation of sequences of bytes of text data as characters (for example, single-byte as opposed to multi-byte characters in arguments and input files).

LC_MESSAGES
    Determine the locale that should be used to affect the format and contents of diagnostic messages written to standard error.

NLSPATH
    Determine the location of message catalogs for the processing of LC_MESSAGES .

ASYNCHRONOUS EVENTS

Default.

STDOUT

The standard output shall be used for the cross-reference listing, unless the -o option is used to select a different output file.

The format of standard output is unspecified, except that the following information shall be included:

*   If the -c option is not specified, each portion of the listing shall start with the name of the input file on a separate line.

*   The name line shall be followed by a sorted list of symbols, each with its associated location pathname, the name of the function in which it appears (if it is not a function name itself), and line number references.

*   Each line number may be preceded by an asterisk ( '*' ) flag, meaning that this is the declaring reference. Other single-character flags, with implementation-defined meanings, may be included.

STDERR

The standard error shall be used only for diagnostic messages.

OUTPUT FILES

The output file named by the -o option shall be used instead of standard output.

EXTENDED DESCRIPTION

None.

EXIT STATUS

The following exit values shall be returned:

0   Successful completion.

>0  An error occurred.

CONSEQUENCES OF ERRORS

Default.

The following sections are informative.

APPLICATION USAGE

None.

EXAMPLES

None.

RATIONALE

None.

FUTURE DIRECTIONS

None.

SEE ALSO

c99

COPYRIGHT
Portions of this text are reprinted and reproduced in electronic form from IEEE Std 1003.1, 2003 Edition, Standard for Information Technology -- Portable Operating System Interface (POSIX), The Open Group Base Specifications Issue 6, Copyright (C) 2001-2003 by the Institute of Electrical and Electronics Engineers, Inc and The Open Group. In the event of any discrepancy between this version and the original IEEE and The Open Group Standard, the original IEEE and The Open Group Standard is the referee document. The original Standard can be obtained online at http://www.opengroup.org/unix/online.html .